#!/bin/bash

echo -e "####################################################"
echo -e "Este script foi desenvolvido para atualização de ADM"
echo -e "####################################################"
echo -e " "
echo -e "Será feito o download da versão que você digitar abaixo: "
echo -e "####################################################"
sleep 1
read -p "Digite a versão do adm: " versaoadm
#read -p "Digite seu usuário do Jenkins para baixar novo adm: " user
#read -s -p "Digite sua senha do Jenkins: " pass
echo -e " "
echo -e "Baixando ADM versão --> $versaoadm <-- para atualização."
echo -e " "
rm -rf /tmp/ventaboletosadm.war
#curl http://18.235.188.113:1313/job/Adm/job/Adm-Project-Build/$versaoadm/artifact/target/ventaboletosadm.war -u $user:$pass -O
curl -O http://52.5.53.15:8081/nexus/content/repositories/releases/br/com/rjconsultores/ventaboletosadm/$versaoadm/ventaboletosadm-$versaoadm.war
mv ventaboletosadm-$versaoadm.war /tmp/ventaboletosadm.war
sleep 2
echo -e " "
adms=$(ls /etc/systemd/system/ | grep ^wild* | sort | cut -d "." -f 1)
echo -e "####################################################"
echo -e "##### Listando ADMs que rodam  neste servidor: #####"
echo -e "####################################################"
echo -e "$adms"
read -p "***COPIE e COLE*** ADM listado que deseja atualizar: " adm
echo -e " "
case $adm in
        $adm)
                echo -e "Você COPIOU e COLOU >>>>>>> $adm <<<<<<<<"
                echo -e "...verificando..."
		echo -e " "
                portconf=$(cat /dados/$adm/standalone/configuration/standalone.xml | grep "socket-binding-group name" | cut -d ":" -f 2 | tr -d '}">')
                portconsole=$(expr $portconf + 9990)
                echo -e "A porta da console é: $portconsole"
                sleep 3
                echo -e " "
		echo -e "#############################################################################################"
                echo -e "Apagando backups antigos com mais de 14 dias..."
                find "/dados/" -type d -name 'bkp_ADM_*' -mtime +14 -exec rm -rf {} \;
                echo -e " "
		echo -e "#############################################################################################"
		echo -e "Apagando backups antigos com mais de 14 dias..."
		find "/dados/bkp_ADM/" -type d -name '*' -mtime +14 -exec rm -rf {} \; 

		##ls /dados/$adm/standalone/deployments/ventaboletosadm.war.*
		#ls /dados/$adm/standalone/deployments/ventaboletosadm.war*
		#if [ $? -eq 0 ]; then
		#	mv /dados/$adm/standalone/deployments/ventaboletosadm.war* /tmp/
		VER="/dados/$adm/standalone/deployments/ventaboletosadm*"
		if [ -e $VER ]; then
			mv $VER /opt/
		else	
                	echo -e "***Iniciando backup do "ventaboletosadm.war" de " $adm " ..."
		fi
		echo -e " "
		time=$(date +%Y-%m-%d-%H-%M)
		mkdir -p /dados/bkp_ADM/$adm-$time
		bkp=/dados/bkp_ADM/$adm-$time
                export JAVA_HOME=/dados/jdk-11.0.5
		/dados/$adm/bin/jboss-cli.sh --user=admin --password=rjmaster09 --connect controller=localhost:$portconsole --commands="attachment save --operation=/deployment=ventaboletosadm.war:read-content() --file=$bkp/ventaboletosadm.war"
		sleep 2
		echo -e " "
		echo "################################################################################################"
		echo -e "Iniciando Atualização do ADM de $adm ..."
		echo -e " "
		sleep 2
		echo -e "***Você pode duplicar este terminal e acompanhar o log com o comando abaixo: ***"
                echo -e " "
                echo -e "tail -f /dados/$adm/standalone/log/server.log"
                export JAVA_HOME=/dados/jdk-11.0.5
                /dados/$adm/bin/jboss-cli.sh --user=admin --password=rjmaster09 --connect controller=localhost:$portconsole --commands="deployment deploy-file --replace /tmp/ventaboletosadm.war"
               # sleep 3
               # echo -e "Reiniciando ADM $adm"
               # systemctl restart $adm
                ;;
        *)
                echo "Você digitou opção inválida. Execute novamente."
                exit 1 ;;
esac
echo -e "***********************************************************************"
bkpok="$bkp/ventaboletosadm.war"
echo -e "Backup salvo em: $bkpok "
echo -e "***********************************************************************"
echo -e "Favor acessar ADM via browser e validar. *****"
sleep 1
echo -e "***********************************************************************"
echo -e "*****Atualização do " $adm " para a versão $versaoadm finalizada!!!****"
echo -e "***********************************************************************"
